/*Asic_mid.h: function of Asic set;*/
/* sane - Scanner Access Now Easy.

   Copyright (C) 2005 Mustek.
   Originally maintained by Mustek
   Author:Roy 2005.5.24

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

   This file implements a SANE backend for Mustek 1200UB and similar 
   USB flatbed scanners.  */
#ifndef _ASIC_MID_H_
#define _ASIC_MID_H_
#include "asic_usb.h"
#include "../include/public.h"
#include <math.h>



extern STATUS OpenScanChip(PAsic chip);

extern STATUS CloseScanChip(PAsic chip);

extern STATUS SafeInitialChip(PAsic chip);

extern STATUS DRAM_Test(PAsic chip);

extern STATUS SetPowerSave(PAsic chip);

extern STATUS SetLineTimeAndExposure(PAsic chip);

extern STATUS CCDTiming(PAsic chip);

extern STATUS IsCarriageHome(PAsic chip,BOOL* LampHome ,BOOL* TAHome);

extern STATUS InitTiming(PAsic chip);

extern STATUS GetChipStatus(PAsic chip,BYTE Selector, BYTE *ChipStatus);

extern STATUS SetAFEGainOffset(PAsic chip);

extern STATUS SetLEDTime(PAsic chip);

extern STATUS SetScanMode(PAsic chip,BYTE bScanBits);

extern STATUS SetPackAddress(PAsic chip,WORD wXResolution, 
							 WORD wWidth,WORD wX,double XRatioAdderDouble,
							 double XRatioTypeDouble, BYTE byClear_Pulse_Width,
							 WORD *PValidPixelNumber);

extern STATUS SetExtraSetting(PAsic chip,WORD wXResolution,WORD  wCCD_PixelNumber,BOOL isCaribrate);

#endif /* End of file asic_mid.h */
