/* sane - Scanner Access Now Easy.

   Copyright (C) 2005 Mustek.
   Originally maintained by Mustek
   Author:Jack Roy 2005.5.24

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

*/
#ifndef _MustScanner_2005_5_13_
#define _MustScanner_2005_5_13_

#include "../include/typedef.h"
#include "../include/debug.h"


BOOL MustScanner_Init();
BOOL MustScanner_GetScannerState();
BOOL MustScanner_PowerControl(BOOL isLampOn,BOOL isTALampOn);
BOOL MustScanner_BackHome();
BOOL MustScanner_Prepare(BYTE bScanSource);
BOOL MustScanner_AdjustOffset(int nTimes,BOOL *bDirection,BYTE *bOffset,
							  BYTE *bLastMin, BYTE *bLastOffset, WORD *wMinValue, 
							  BYTE *bOffsetUpperBound, BYTE *bOffsetLowerBound, 
							  WORD wStdMinLevel, WORD wStdMaxLevel);
BOOL MustScanner_SecondAdjustOffset(int nTimes, BOOL *bDirection, BYTE *bOffset,
									BYTE *bLastMin, BYTE *bLastOffset, 
									WORD *wMinValue, BYTE *bOffsetUpperBound,
									BYTE *bOffsetLowerBound, WORD wStdMinLevel,
									WORD wStdMaxLevel);
WORD MustScanner_FiltLower(WORD* pSort,WORD TotalCount,WORD LowCount,WORD HighCount);

BOOL MustScanner_GetRgb48BitLine(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);
BOOL MustScanner_GetRgb48BitLine1200DPI(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);

BOOL MustScanner_GetRgb24BitLine(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);
BOOL MustScanner_GetRgb24BitLine1200DPI(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);

BOOL MustScanner_GetMono16BitLine(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);
BOOL MustScanner_GetMono16BitLine1200DPI(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);

BOOL MustScanner_GetMono8BitLine(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);
BOOL MustScanner_GetMono8BitLine1200DPI(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);

BOOL MustScanner_GetMono1BitLine(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);
BOOL MustScanner_GetMono1BitLine1200DPI(BYTE* lpLine,BOOL isOrderInvert,WORD *wLinesCount);

void* MustScanner_ReadDataFromScanner();

void MustScanner_PrepareCalculateMaxMin(WORD wResolution);

void MustScanner_CalculateMaxMin(LPBYTE pBuffer, LPWORD lpMaxValue, LPWORD lpMinValue, WORD wResolution);

BYTE QBET4(BYTE A, BYTE B);

#endif /* end of the file MustScanner.h */
